require "ihome/client"
require "ihome/configuration"
require "ihome/version"

module Ihome

  class ConfigurationMissingError < RuntimeError
    def initialize(msg = "Please use Ihome.configure before trying to initialize a client")
      super(msg)
    end
  end

  def self.configuration
    @configuration
  end

  def self.configure(options = {})
    @configuration = Configuration.new(options)
    # Force refresh
    @oauth2_client = nil
  end

  def self.authorization_url(state)
    self.oauth2_client.auth_code.authorize_url(
      response_type: 'code',
      state: state,
    )
  end

end
